# mfrc_modul_test_gain.py: legt gain der Antenne fest, liest UID von der Karte und gibt sie am Terminal aus
# Test für das Modul mfrc522_ergaenzt.py

# Initialisierungen...

from machine import Pin, SoftSPI
from time import sleep_ms
from mfrc522_ergaenzt import MFRC522 # mit Methoden write_gain und read_gain

sck = Pin(17, Pin.OUT)
mosi = Pin(15, Pin.OUT)
miso = Pin(12, Pin.OUT)
softspi = SoftSPI(baudrate=100000, polarity=0, phase=0, sck=sck, mosi=mosi, miso=miso)

sda = Pin(25, Pin.OUT) # (SDA = ChipSelect)

# Funktionen...
    
def do_read_uid_gain():
    dbliste = ['18dB', '23dB', '18dB', '23dB', '33dB', '38dB', '43dB', '48dB']
    weiter = True
    while weiter:
        gain = int(input('gain (0-7): '))
        if gain < 0 or gain > 7:
            print('Ungültiger Eingabewert!')
        else:
            weiter = False

    try:
        while True:
            rdr = MFRC522(softspi, sda)
            (stat, tag_type) = rdr.request(rdr.REQIDL)
            if stat == rdr.OK:
                (stat, raw_uid) = rdr.anticoll()
                if stat == rdr.OK:
                    print('gain(w): ', dbliste[gain]) # zu speichernder gain (in dB)
                    gain_w = ((gain & 0x7) << 4)
                    rdr.write_gain(gain_w) # Funktion zur Festlegung von gain, welche direkt auf das SPI zurückgreift; Zuordnung gain -> dB s. o. 

                    uid = ("0x%02x%02x%02x%02x" % (raw_uid[0], raw_uid[1], raw_uid[2], raw_uid[3]))
                    print('uid: ', uid)
                    print('gain(r): ', dbliste[(rdr.read_gain() & 0x7f) >> 4])
                    print()
                    sleep_ms(100)
            else:
                print('Keine Karte!')
                    
    except KeyboardInterrupt:
        print()
        print('Tschüss!')

# Hauptprogramm...

print('Karte!')
print('Exit mit Strg-C')
do_read_uid_gain()        